import java.io.*;

public class DemoWriter
{
    public static void fileWriter() throws IOException {
         FileWriter writer = new FileWriter("out.txt");
         
         try {
             writer.write('a');
             writer.write("a");
             writer.write("ahoj");
             //writer.write("\n"); // toto neni univerzalni oddelovac
             writer.write(System.getProperty("line.separator"));
             writer.write("č");
        } finally { 
             writer.close();
        }
    }
    
    public static void fileWriter2() throws IOException {
         FileWriter writer = new FileWriter("out.txt"); // opens the file!
         BufferedWriter bw = new BufferedWriter(writer); // does not open anything!
         
         //BufferedWriter bw = new BufferedWriter(new FileWriter("out.txt"));
         
         try {
             bw.write('a');
             bw.write("a");
             bw.write("ahoj");
             //writer.write("\n"); // toto neni univerzalni oddelovac
             //bw.write(System.getProperty("line.separator"));
             bw.newLine();
             bw.write("č");
        } finally { 
             //writer.close();
             bw.close();
        }
    }
    
    public static void fileWriter3(Writer writer) throws IOException {
         BufferedWriter bw = new BufferedWriter(writer);
         
         //BufferedWriter bw = new BufferedWriter(new FileWriter("out.txt"));
         
         try {
             bw.write('a');
             
             bw.write("a");
             bw.write("ahoj");
             //writer.write("\n"); // toto neni univerzalni oddelovac
             //bw.write(System.getProperty("line.separator"));
             bw.newLine();
             bw.write("č");
        } finally { 
            bw.flush();
            //bw.close(); // CHYBA!!!
        }
    }
    
    public static void fileWriter4() throws IOException {
        FileWriter writer = new FileWriter("out.txt");
        try {
            fileWriter3(writer);
        } finally {
            writer.close();
        }
    }
}
